@echo off
cd /d "%~dp0"
color 0e
title mRatio Fixer v7 / Multiple Instance Unlocker

if not exist handle.--- (
	title mRatio Fixer v7 / Error
	echo handle.--- is missing.
	goto exit
)

rem Cheap (but effective) method of checking for administrator privileges
net session 1>nul 2>&1 && goto main
title mRatio Fixer v7 / Error
echo This script requires administrator privileges. To run it, you should:
echo   * Right-click on %~nx0
echo   * Click on "Run as administrator"
echo   * Click on "Yes" in the User Account Control prompt
echo.
echo Press any key to exit...&pause >nul&exit /b

:main
echo This will unlock support for running multiple instances of mRatio by
echo closing the BaseNamedObjects handles it uses to detect them. Please
echo keep a few things in mind:
echo   * The stability of using this method is not known, let alone
echo     guaranteed. Patching mRatio's executable is more likely to be
echo     reliable.
echo   * Each instance you run _must_ be installed in a separate directory
echo     to prevent conflicts arising from sharing configuration files. It's
echo     up to you to enforce this, as mRatio will not be able to do it
echo     (because we're removing the instance check, remember?).
echo   * Listen ports cannot be shared among instances, but in practice this
echo     doesn't matter much because mRatio only binds to a port to complete
echo     a TCP handshake and appear connectable on the tracker, no
echo     application data is sent.
echo   * This script must be rerun for each new instance you want to open
echo     (in order to close the handles created by the last one that ran).
echo.
:prompt
choice /c yn /n /m "Do you want to unlock multiple instances now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&goto next
if %ERRORLEVEL%==2 goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:next
echo Detecting mRatio process...
for /f "usebackq tokens=3 delims=: " %%a in (`handle.--- -a -p mRatio.exe "ef61c32a-b246-42be-8216-fe0600d45bb7" -accepteula -nobanner`) do (
	if "%%a"=="handles" (
		echo Failed ^(is mRatio running? Have multiple instances already been unlocked?^).
		goto exit
	)
)

echo Unlocking multiple instances...
for /f "usebackq tokens=3,6 delims=: " %%a in (`handle.--- -a -p mRatio.exe "ef61c32a-b246-42be-8216-fe0600d45bb7" -accepteula -nobanner`) do (
	handle.--- -c %%b -y -p %%a -accepteula -nobanner 1>nul 2>&1
)

:exit
echo Press any key to exit...
pause >nul
exit /b
